// MainDlg.cpp : implementation of the CMainDlg class
//
/////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "resource.h"

#include "MainDlg.h"

#define TIMER_REPAINT 123
#define SPEED_REPAINT 80 // mili sec -  ,    ...   '' ...

#define WM_ASYNC_ACTIVATE (WM_USER + 1)

CMainDlg::CMainDlg() :
   m_sizeView(::GetScreenSize()),
   m_hDC(NULL),
   m_hBmpView(NULL),
   m_Grad(GradientColors(9, 0x900)),
   m_hMod(NULL),
   m_bLoadLib(FALSE),
   m_uMsgAsyncActivate(0),
   m_uMsgAsyncSelectFolder(0)
{
   //       ...
   BOOL bRes = ::SetPriorityClass(::GetCurrentProcess(), BELOW_NORMAL_PRIORITY_CLASS);
   _ASSERT(bRes);

   m_uMsgAsyncActivate = ::RegisterWindowMessage(_T("WM_ASYNC_ACTIVATE")); _ASSERT(m_uMsgAsyncActivate);
   m_uMsgAsyncSelectFolder = ::RegisterWindowMessage(_T("WM_ASYNC_SELECT_FOLDER")); _ASSERT(m_uMsgAsyncSelectFolder);
}

BOOL CMainDlg::OnInitDialog(HWND /*hwndFocus*/, LPARAM /*lParam*/)
{
   // center the dialog on the screen
///   CenterWindow();

   // set icons
   HICON hIcon = (HICON)::LoadImage(_Module.GetResourceInstance(), MAKEINTRESOURCE(IDR_MAINFRAME), 
      IMAGE_ICON, ::GetSystemMetrics(SM_CXICON), ::GetSystemMetrics(SM_CYICON), LR_DEFAULTCOLOR);
   SetIcon(hIcon, TRUE);
   HICON hIconSmall = (HICON)::LoadImage(_Module.GetResourceInstance(), MAKEINTRESOURCE(IDR_MAINFRAME), 
      IMAGE_ICON, ::GetSystemMetrics(SM_CXSMICON), ::GetSystemMetrics(SM_CYSMICON), LR_DEFAULTCOLOR);
   SetIcon(hIconSmall, FALSE);

   { // SCROLL
      //     ,    - -
      SCROLLINFO scInfoHorz = {
         sizeof(SCROLLINFO),              // UINT    cbSize;
         SIF_RANGE | SIF_PAGE | SIF_POS,  // UINT    fMask;
         0,                               // int     nMin;
         m_sizeView.cx<<1,                 // int     nMax;
         m_sizeView.cx>>1,              // UINT    nPage;
         0,                               // int     nPos;
         0                                // int     nTrackPos;
      };
      SetScrollInfo(SB_HORZ, &scInfoHorz, TRUE);
      SCROLLINFO scInfoVert = {
         sizeof(SCROLLINFO),
         SIF_RANGE | SIF_PAGE | SIF_POS,
         0, m_sizeView.cy<<1,
         m_sizeView.cy>>1,
         0, 0
      };
      SetScrollInfo(SB_VERT, &scInfoVert, TRUE);
   }

   CreateCompatibleDC_and_Bmp();

   UINT_PTR nIDEvent = SetTimer(TIMER_REPAINT, SPEED_REPAINT, NULL); _ASSERT(nIDEvent); // elapse to repaint

   //::OutputDebugString(_T("CMainDlg::OnInitDialog: \r\n"));
   return TRUE;
}

void CMainDlg::OnActivateApp(BOOL bActive, DWORD dwThreadID) {
   //::OutputDebugString(_T("CMainDlg::OnActivateApp: \r\n"));
}
void CMainDlg::OnActivate(UINT nState, BOOL bMinimized, CWindow wndOther) {
   //::OutputDebugString(_T("CMainDlg::OnActivate: \r\n"));
}
LRESULT CMainDlg::OnAsyncActive(UINT uMsg, WPARAM wParam, LPARAM lParam) {
   //::OutputDebugString(_T("CMainDlg::OnPostActive: \r\n"));

   SelectAndLoadMod();

   LoadIcoFromModule();
   LoadBmpFromModule();

   SelectFolder();

   LoadIcoFromDir();
   LoadBmpFromDir();

   UpdateWindow();

   return 0L;
}
void CMainDlg::OnShowWindow(BOOL bShow, UINT nStatus) {
   //::OutputDebugString(_T("CMainDlg::OnShowWindow: \r\n"));
   if (bShow && !m_hMod)
      PostMessage(m_uMsgAsyncActivate, 0,0);
}
void CMainDlg::OnChangeUIState(WORD nAction, WORD nState) {
   //::OutputDebugString(_T("CMainDlg::OnChangeUIState: \r\n"));
}

void CMainDlg::OnDestroy() {
   HGDIOBJ hBmp = ::SelectObject(m_hDC, m_hBmpViewOld); _ASSERT(hBmp == m_hBmpView);
   BOOL bRes = ::DeleteObject(m_hBmpView); _ASSERT(bRes); m_hBmpView = NULL;
   bRes = ::DeleteDC(m_hDC); _ASSERT(bRes); m_hDC = NULL;

   FreeMod();
}

void CMainDlg::OnClose(UINT uNotifyCode, int nID, CWindow wndCtl)
{
   EndDialog(nID);
}

void CMainDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar pScrollBar) {
   SCROLLINFO scInfo = {sizeof(SCROLLINFO), SIF_RANGE | SIF_PAGE | SIF_POS};
   BOOL bRes = GetScrollInfo(SB_HORZ, &scInfo); _ASSERT(bRes);
   switch (nSBCode) {
   case SB_LEFT         : scInfo.nPos = scInfo.nMin; break;
   case SB_RIGHT        : scInfo.nPos = scInfo.nMax; break;
   case SB_LINELEFT     : scInfo.nPos = max(scInfo.nMin, int(scInfo.nPos-scInfo.nPage/10)); break;
   case SB_LINERIGHT    : scInfo.nPos = min(scInfo.nMax, int(scInfo.nPos+scInfo.nPage/10)); break;
   case SB_PAGELEFT     : scInfo.nPos = max(scInfo.nMin, int(scInfo.nPos-scInfo.nPage)); break;
   case SB_PAGERIGHT    : scInfo.nPos = min(scInfo.nMax, int(scInfo.nPos+scInfo.nPage)); break;
   case SB_THUMBPOSITION:
   case SB_THUMBTRACK   : scInfo.nPos = nPos; break;
   case SB_ENDSCROLL    : break;
   }
   scInfo.fMask = SIF_POS;
   SetScrollInfo(SB_HORZ, &scInfo, TRUE);
   bRes = InvalidateRect(NULL, TRUE); _ASSERT(bRes);
}

void CMainDlg::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar pScrollBar) {
   SCROLLINFO scInfo = {sizeof(SCROLLINFO), SIF_RANGE | SIF_PAGE | SIF_POS};
   BOOL bRes = GetScrollInfo(SB_VERT, &scInfo); _ASSERT(bRes);
   switch (nSBCode) {
   case SB_TOP          : scInfo.nPos = scInfo.nMin; break;
   case SB_BOTTOM       : scInfo.nPos = scInfo.nMax; break;
   case SB_LINEUP       : scInfo.nPos = max(scInfo.nMin, int(scInfo.nPos-scInfo.nPage/10)); break;
   case SB_LINEDOWN     : scInfo.nPos = min(scInfo.nMax, int(scInfo.nPos+scInfo.nPage/10)); break;
   case SB_PAGEUP       : scInfo.nPos = max(scInfo.nMin, int(scInfo.nPos-scInfo.nPage)); break;
   case SB_PAGEDOWN     : scInfo.nPos = min(scInfo.nMax, int(scInfo.nPos+scInfo.nPage)); break;
   case SB_THUMBPOSITION:
   case SB_THUMBTRACK   : scInfo.nPos = nPos; break;
   case SB_ENDSCROLL    : break;
   }
   scInfo.fMask = SIF_POS;
   SetScrollInfo(SB_VERT, &scInfo, TRUE);
   bRes = InvalidateRect(NULL, TRUE); _ASSERT(bRes);
}
BOOL CMainDlg::OnMouseWheel(UINT nFlags, short zDelta, CPoint pt) {
   OnVScroll(
      (zDelta > 0) ? SB_LINEUP : SB_LINEDOWN,
      0, NULL);
   return TRUE;
}

void CMainDlg::OnPaint(CDCHandle _dc) {
   CPaintDC dc(m_hWnd);
   PaintBackground();
   PaintImages();
   ::BitBlt((HDC)dc, dc.m_ps.rcPaint, m_hDC, POINTEX(), SRCCOPY);
}

void CMainDlg::PaintImages() {
   SIZE scrl = getScrollOffset();
   ::SetBkMode(m_hDC, TRANSPARENT);

   ////////////////
   // draw Icons //
   ////////////////
   static struct QQQ{
      const ARR_Icons &arr;
      const CString  caption;
      QQQ(const ARR_Icons &a, LPCTSTR s) : arr(a), caption(s) {}
   } descriptorIco[] = {
      QQQ(m_arrIcoRcAllFrames            , _T("   ")                     ),
      QQQ(m_arrIcoRcAllFramesFromGroup   , _T("     (  )")),
      QQQ(m_arrIcoRcAllFramesFromGroupLng, _T("     (  )") ),
      QQQ(m_arrIcoAllDirFrames           , _T("    ")              )
   };

   int iMaxX = 0;
   int iHeaderY = 0;
   for (UINT i=0; i<chDIMOF(descriptorIco); i++) {
      int maxImgY = 0;
      int iOffX = 0;
      int iOffY = iHeaderY+40;

      const ARR_Icons &arr = descriptorIco[i].arr;
      if (arr.size() == 0)
         continue;
      SIZE sizeTxtD = {0,0}; // description text
      SIZE sizeTxt  = {0,0}; // file name or resource name
      SIZE sizeTxtS = {0,0}; // size
      ::GetTextExtentPoint32(m_hDC, descriptorIco[i].caption, descriptorIco[i].caption.GetLength(), &sizeTxtD);
      ::DrawText(m_hDC, descriptorIco[i].caption, -1, &RECTEX(
         -scrl.cx+5,
         -scrl.cy+iHeaderY,
         -scrl.cx+5+       sizeTxtD.cx,
         -scrl.cy+iHeaderY+sizeTxtD.cy), DT_LEFT);
      for (ARR_Icons::const_iterator k=arr.begin(); k!=arr.end(); k++) {
         const CString &strText = k->m_name;
         const ARR_IcoFrames &icons = k->m_frames;
         ::GetTextExtentPoint32(m_hDC, strText, strText.GetLength(), &sizeTxt);
         ::DrawText(m_hDC, strText, -1, &RECTEX(
            -scrl.cx+iOffX,
            -scrl.cy+iHeaderY+sizeTxtD.cy,
            -scrl.cx+iOffX   +            sizeTxt.cx,
            -scrl.cy+iHeaderY+sizeTxtD.cy+sizeTxt.cy), DT_LEFT);
         int iAllIcoX = 0;
         for (ARR_IcoFrames::const_iterator j=icons.begin(); j!=icons.end(); j++) {
            HICON hIco = j->m_hIco;
            if (hIco == NULL)
               continue;
            //SIZE s = ::SizeIcon(hIco);
            SIZE s = j->m_sizeIco;
            CString strSize; strSize.Format(_T("%ix%i"), s.cx, s.cy);
            ::GetTextExtentPoint32(m_hDC, strSize, strSize.GetLength(), &sizeTxtS);
            ::DrawText(m_hDC, strSize, -1, &RECTEX(
               -scrl.cx+iOffX+iAllIcoX,
               -scrl.cy+iOffY+s.cy,
               -scrl.cx+iOffX+iAllIcoX+max(sizeTxtS.cx, s.cx),
               -scrl.cy+iOffY+s.cy+sizeTxtS.cy), DT_CENTER);
            //_ASSERT(s == ::SizeIcon(hIco));
            ::DrawIconEx(m_hDC,
               -scrl.cx+iOffX+iAllIcoX + ((s.cx>sizeTxtS.cx) ? 0 : (sizeTxtS.cx-s.cx)>>1),
               -scrl.cy+iOffY, hIco,
               s.cx,
               s.cy, 0, NULL, DI_NORMAL);
            iAllIcoX += max(s.cx, sizeTxtS.cx)+2;
            maxImgY = max(maxImgY, s.cy);
         }
         iOffX += max(iAllIcoX, sizeTxt.cx)+5;
         ::MoveToEx(m_hDC, -scrl.cx+iOffX-2, -scrl.cy+iHeaderY+sizeTxtD.cy, NULL);
         ::LineTo(m_hDC, -scrl.cx+iOffX-2, -scrl.cy+iHeaderY+sizeTxtD.cy+sizeTxt.cy+sizeTxtS.cy+maxImgY+15);

         iMaxX = max(iMaxX,iOffX);
      }
      iHeaderY += maxImgY+sizeTxtD.cy+sizeTxt.cy+sizeTxtS.cy+15;
      ::MoveToEx(m_hDC, 0        , -scrl.cy+iHeaderY, NULL);
      ::LineTo  (m_hDC, m_sizeView.cx, -scrl.cy+iHeaderY);
   }

   //////////////////
   // draw Bitmaps //
   //////////////////
   static struct QQQ2{
      const ARR_Bitmaps &arr;
      const CString  caption;
      QQQ2(const ARR_Bitmaps &a, LPCTSTR s) : arr(a), caption(s) {}
   } descriptorBmp[] = {
      QQQ2(m_arrBmpRcAll   , _T("    (  )")),
      QQQ2(m_arrBmpRcAllLng, _T("    (  )") ),
      QQQ2(m_arrBmpDirAll  , _T("   ")                  )
   };

   for (UINT i=0; i<chDIMOF(descriptorBmp); i++) {
      int maxImgY = 0;
      int iOffX = 0;
      int iOffY = iHeaderY+40;

      const ARR_Bitmaps &arr = descriptorBmp[i].arr;
      if (arr.size() == 0)
         continue;
      SIZE sizeTxtD = {0,0}; // description text
      SIZE sizeTxt  = {0,0}; // file name or resource name
      SIZE sizeTxtS = {0,0}; // size
      ::GetTextExtentPoint32(m_hDC, descriptorBmp[i].caption, descriptorBmp[i].caption.GetLength(), &sizeTxtD);
      ::DrawText(m_hDC, descriptorBmp[i].caption, -1, &RECTEX(
         -scrl.cx+5,
         -scrl.cy+iHeaderY,
         -scrl.cx+5+       sizeTxtD.cx,
         -scrl.cy+iHeaderY+sizeTxtD.cy), DT_LEFT);
      for (ARR_Bitmaps::const_iterator k=arr.begin(); k!=arr.end(); k++) {
         const HBITMAP &hBmp    = k->m_hBmp;
         const SIZE    &s       = k->m_sizeBmp;
         const CString &strText = k->m_name;
         if (hBmp == NULL)
            continue;
         ::GetTextExtentPoint32(m_hDC, strText, strText.GetLength(), &sizeTxt);
         ::DrawText(m_hDC, strText, -1, &RECTEX(
            -scrl.cx+iOffX,
            -scrl.cy+iHeaderY+sizeTxtD.cy,
            -scrl.cx+iOffX   +            sizeTxt.cx,
            -scrl.cy+iHeaderY+sizeTxtD.cy+sizeTxt.cy), DT_LEFT);
         CString strSize; strSize.Format(_T("%ix%i"), s.cx, s.cy);
         ::GetTextExtentPoint32(m_hDC, strSize, strSize.GetLength(), &sizeTxtS);
         ::DrawText(m_hDC, strSize, -1, &RECTEX(
            -scrl.cx+iOffX,
            -scrl.cy+iOffY+s.cy,
            -scrl.cx+iOffX+max(sizeTxtS.cx, s.cx),
            -scrl.cy+iOffY+s.cy+sizeTxtS.cy), DT_CENTER);
         _ASSERT(s == ::SizeBitmap(hBmp));
         /** /
         //     .
         ::BitBltMasked(m_hDC, 
            RECTEX(s).move(
               -scrl.cx+iOffX + ((s.cx>sizeTxtS.cx) ? 0 : (sizeTxtS.cx-s.cx)>>1),
               -scrl.cy+iOffY),
            hBmp,
            POINTEX(), CLR_INVALID);
         /**/
         //     .
         ::DrawBitmap(
            m_hDC,
            RECTEX(s).move(
               -scrl.cx+iOffX + ((s.cx>sizeTxtS.cx) ? 0 : (sizeTxtS.cx-s.cx)>>1),
               -scrl.cy+iOffY),
            hBmp,
            POINTEX());
         /**/
         maxImgY = max(maxImgY, s.cy);
         iOffX += max(max(s.cx, sizeTxtS.cx)+2, sizeTxt.cx)+5;
         ::MoveToEx(m_hDC, -scrl.cx+iOffX-2, -scrl.cy+iHeaderY+sizeTxtD.cy, NULL);
         ::LineTo(m_hDC, -scrl.cx+iOffX-2, -scrl.cy+iHeaderY+sizeTxtD.cy+sizeTxt.cy+sizeTxtS.cy+maxImgY+15);

         iMaxX = max(iMaxX,iOffX);
      }
      iHeaderY += maxImgY+sizeTxtD.cy+sizeTxt.cy+sizeTxtS.cy+15;
      ::MoveToEx(m_hDC, 0        , -scrl.cy+iHeaderY, NULL);
      ::LineTo  (m_hDC, m_sizeView.cx, -scrl.cy+iHeaderY);
      
   }
}

void CMainDlg::PaintBackground() {
   //{ // fill - PatBlt
   //   HBRUSH hBrush = (HBRUSH)::GetStockObject(WHITE_BRUSH);//::CreateSolidBrush(0xFF0000); _ASSERT(hBrush); //::GetSysColorBrush(COLOR_WINDOW); // ::GetStockObject(WHITE_BRUSH);
   //   HGDIOBJ hBrushOld = ::SelectObject(m_hDC, hBrush); _ASSERT(hBrushOld);
   //   BOOL bRes = ::PatBlt(m_hDC, 0,0, m_sizeView.cx, m_sizeView.cy, PATCOPY); _ASSERT(bRes);
   //   ::SelectObject(m_hDC, hBrushOld);
   //   //bRes = ::DeleteObject(hBrush); _ASSERT(bRes);
   //   //return;
   //}

   { // fill - gragient

      static BYTE foreach = 0; //    0xFF,   -   0x00.   ...
      static bool inc = true;
      if (inc) {
         foreach++; if (0xFF == foreach) inc = !inc;
      } else {
         foreach--; if (0x00 == foreach) inc = !inc;
      }
      BYTE clarifier = foreach; //  
      //BYTE clarifier = 0x7F; //  

      TRIVERTEX vert[] = {
         {
            0,                 // LONG    x;
            0,                 // LONG    y;
            m_Grad.getColor(0, GradientColors::r, clarifier),  // COLOR16 Red;   0x0000..0xff00
            m_Grad.getColor(0, GradientColors::g, clarifier),  // COLOR16 Green;
            m_Grad.getColor(0, GradientColors::b, clarifier),  // COLOR16 Blue;
            // non - ...    m_Grad.getColor(0, GradientColors::a),  // COLOR16 Alpha;
         }, {
            0,               // LONG    x;
            m_sizeView.cy,   // LONG    y;   
            m_Grad.getColor(1, GradientColors::r, clarifier),  // COLOR16 Red;   0x0000..0xff00
            m_Grad.getColor(1, GradientColors::g, clarifier),  // COLOR16 Green;
            m_Grad.getColor(1, GradientColors::b, clarifier),  // COLOR16 Blue;
            // non - ...    m_Grad.getColor(1, GradientColors::a),  // COLOR16 Alpha;
         }, {
            m_sizeView.cx,   // LONG    x;
            m_sizeView.cy,   // LONG    y;   
            m_Grad.getColor(2, GradientColors::r, clarifier),  // COLOR16 Red;   0x0000..0xff00
            m_Grad.getColor(2, GradientColors::g, clarifier),  // COLOR16 Green;
            m_Grad.getColor(2, GradientColors::b, clarifier),  // COLOR16 Blue;
            // non - ...    m_Grad.getColor(2, GradientColors::a),  // COLOR16 Alpha;
         }, {
            m_sizeView.cx,   // LONG    x;
            0,               // LONG    y;   
            m_Grad.getColor(3, GradientColors::r, clarifier),  // COLOR16 Red;   0x0000..0xff00
            m_Grad.getColor(3, GradientColors::g, clarifier),  // COLOR16 Green;
            m_Grad.getColor(3, GradientColors::b, clarifier),  // COLOR16 Blue;
            // non - ...    m_Grad.getColor(3, GradientColors::a),  // COLOR16 Alpha;
         }, {
            m_sizeView.cx>>1,  // LONG    x;
            m_sizeView.cy>>1,  // LONG    y;   
            m_Grad.getColor(4, GradientColors::r, clarifier),  // COLOR16 Red;   0x0000..0xff00
            m_Grad.getColor(4, GradientColors::g, clarifier),  // COLOR16 Green;
            m_Grad.getColor(4, GradientColors::b, clarifier),  // COLOR16 Blue;
            // non - ...    m_Grad.getColor(4, GradientColors::a),  // COLOR16 Alpha;
         }, {
            0,                 // LONG    x;
            m_sizeView.cy>>1,  // LONG    y;   
            m_Grad.getColor(5, GradientColors::r, clarifier),  // COLOR16 Red;   0x0000..0xff00
            m_Grad.getColor(5, GradientColors::g, clarifier),  // COLOR16 Green;
            m_Grad.getColor(5, GradientColors::b, clarifier),  // COLOR16 Blue;
            // non - ...    m_Grad.getColor(5, GradientColors::a),  // COLOR16 Alpha;
         }, {
            m_sizeView.cx>>1,  // LONG    x;
            0,                 // LONG    y;   
            m_Grad.getColor(6, GradientColors::r, clarifier),  // COLOR16 Red;   0x0000..0xff00
            m_Grad.getColor(6, GradientColors::g, clarifier),  // COLOR16 Green;
            m_Grad.getColor(6, GradientColors::b, clarifier),  // COLOR16 Blue;
            // non - ...    m_Grad.getColor(5, GradientColors::a),  // COLOR16 Alpha;
         }, {
            m_sizeView.cx,     // LONG    x;
            m_sizeView.cy>>1,  // LONG    y;   
            m_Grad.getColor(7, GradientColors::r, clarifier),  // COLOR16 Red;   0x0000..0xff00
            m_Grad.getColor(7, GradientColors::g, clarifier),  // COLOR16 Green;
            m_Grad.getColor(7, GradientColors::b, clarifier),  // COLOR16 Blue;
            // non - ...    m_Grad.getColor(6, GradientColors::a),  // COLOR16 Alpha;
         }, {
            m_sizeView.cx>>1,  // LONG    x;
            m_sizeView.cy,     // LONG    y;   
            m_Grad.getColor(8, GradientColors::r, clarifier),  // COLOR16 Red;   0x0000..0xff00
            m_Grad.getColor(8, GradientColors::g, clarifier),  // COLOR16 Green;
            m_Grad.getColor(8, GradientColors::b, clarifier),  // COLOR16 Blue;
            // non - ...    m_Grad.getColor(8, GradientColors::a),  // COLOR16 Alpha;
         }
      };

      // 0 3
      // 1 2
      //GRADIENT_TRIANGLE gTri[] =  {{0, 1, 2}, {0, 3, 2}};
      //BOOL bRes = ::GradientFill(m_hDC, vert, chDIMOF(vert), &gTri, chDIMOF(gTri), GRADIENT_FILL_TRIANGLE); _ASSERT(bRes);

      
      // 0   3
      //   4
      // 1   2
      //GRADIENT_TRIANGLE gTri[] =  {{0, 1, 4}, {1, 2, 4}, {2, 3, 4}, {0, 3, 4}};
      //BOOL bRes = ::GradientFill(m_hDC, vert, chDIMOF(vert), &gTri, chDIMOF(gTri), GRADIENT_FILL_TRIANGLE); _ASSERT(bRes);

      // 0   6   3
      // 5 / 4 \ 7
      // 1 \ 8 / 2
      GRADIENT_TRIANGLE gTri[] =  {{0, 5, 6}, {5, 6, 4}, {6, 4, 7}, {6, 3, 7},
                                   {5, 1, 8}, {5, 4, 8}, {4, 8, 7}, {7, 8, 2}};
      BOOL bRes = ::GradientFill(m_hDC, vert, chDIMOF(vert), &gTri, chDIMOF(gTri), GRADIENT_FILL_TRIANGLE); _ASSERT(bRes);
   }
}

void CMainDlg::OnTimer(UINT_PTR nIDEvent) {
   switch (nIDEvent) {
   case TIMER_REPAINT:
      m_Grad.NextIteration();
      InvalidateRect(NULL, TRUE);
      break;
   }
}

void CMainDlg::CreateCompatibleDC_and_Bmp() {
   if (!m_hDC)
      m_hDC = ::CreateCompatibleDC(NULL); _ASSERT(m_hDC);

   if (!m_hBmpView) {
      HDC hDC = ::GetDC(m_hWnd);
      m_hBmpView = ::CreateCompatibleBitmap(hDC, m_sizeView.cx, m_sizeView.cy); _ASSERT(m_hBmpView);
      //BITMAP bmp = {0,0,0,0,0,0,NULL};
      //int iRes = ::GetObject(m_hBmpView, sizeof(BITMAP), &bmp);
      ::ReleaseDC(m_hWnd, hDC);
      m_hBmpViewOld = ::SelectObject(m_hDC, m_hBmpView); _ASSERT(m_hBmpViewOld);
   }
}

SIZE CMainDlg::getScrollOffset() {
   SIZE scrl = {+GetScrollPos(SB_HORZ),
                +GetScrollPos(SB_VERT)};
   return scrl;
}

void CMainDlg::FreeMod() {
   if (m_hMod) {
      if (m_bLoadLib) {
         BOOL bRes = ::FreeLibrary(m_hMod); _ASSERT(bRes);
      }
      m_hMod = NULL;
      m_bLoadLib = FALSE;
   }
}

LRESULT CMainDlg::OnAsyncSelectFolder(UINT uMsg, WPARAM wParam, LPARAM lParam) {
   HWND hWndFocus = ::GetFocus();
   m_strImageFolder = ::GetFileDir(m_strModule);
#if _DEBUG
   if (0 == m_strModule.CompareNoCase(::GetModuleFileName()))
      if (!m_strImageFolder.IsEmpty()) {
         m_strImageFolder = m_strImageFolder.Mid(0, m_strImageFolder.GetLength()-1);
         int iF = m_strImageFolder.ReverseFind(_T('\\'));
         if (iF>=0) {
            m_strImageFolder = m_strImageFolder.Left(iF);
            m_strImageFolder += _T("\\res\\");
         }
      }
#endif
   ::SetWindowText(hWndFocus, m_strImageFolder);
   return 0;
}
void CMainDlg::SelectFolder() {
   PostMessage(m_uMsgAsyncSelectFolder, 0,0);
   m_strImageFolder = ::SelectFolder(m_hWnd, _T("Select ICO/BMP folder"));
}

void CMainDlg::SelectAndLoadMod() {
   FreeMod();

   m_strModule = ::SelectFile(TRUE, m_hWnd, ::GetModuleFileName(), NULL,
      _T("Executable files(*.dll; *.exe)\0*.dll; *.exe\0\0"),
      _T("Select icons container"));

   if (!m_strModule.IsEmpty()) {
      m_hMod = ::GetLibrary(m_strModule, TRUE, m_bLoadLib);
      DWORD dwErrCode = ::GetLastError();
      _ASSERT(m_hMod);
      if (!m_hMod) {
         alert(_T("Load library ["+ m_strModule +"]\n")+::ErrCode2Str(dwErrCode));
      }
   }

   if (m_hMod == NULL) {
      m_strModule = ::GetModuleFileName();
      m_hMod = ::GetModuleInstance();
      m_bLoadLib = FALSE;
   }
}

void CMainDlg::LoadIcoFromModule() {

   //    
   WORD wFrames = ::GetIconFrames(m_hMod);
   if (wFrames == 0) {
      alert(_T("ICO resource not found...\n")+::ErrCode2Str());
   }
   WORD i = 0;
   for (i=1; i<=wFrames; i++) {
      HICON hIco = ::LoadIcon(m_hMod, i);
      if (hIco == NULL)
         continue;
      ARR_IcoFrames arr; arr.push_back(CFrameInfo(
         hIco,
         ::SizeIcon(m_hMod, i)));
      m_arrIcoRcAllFrames.push_back(CIcoInfo(arr, ::Format(_T("%i"), (int)i)));
   }

   //      (  ) (    )
   WORD wGroups = GetIconCount(m_hMod, FALSE); //    wGroups
   CRcName *pNames = new CRcName[wGroups];
   GetIconGroupNames(m_hMod, pNames, wGroups); //   
   for (WORD j=0; j<wGroups; j++) {
      CRcName &name = pNames[j];
      wFrames = ::GetIconFrames(m_hMod, name.getName_raw());
      ARR_IcoFrames arr;
      for (i=0; i<wFrames; i++) {
         HICON hIco = ::LoadIcon(m_hMod, i, name.getName_raw());
         if (hIco == NULL)
            continue;
         arr.push_back(CFrameInfo(
            hIco,
            ::SizeIcon(m_hMod, i, name.getName_raw())));
      }
      m_arrIcoRcAllFramesFromGroup.push_back(CIcoInfo(
         arr,
         name.getNameValue()));
   }
   delete [] pNames;

   //      (  )
   wGroups = GetIconCount(m_hMod, TRUE); //    wGroups
   CRcNameEx *pNamesEx = new CRcNameEx[wGroups];
   GetIconGroupNamesEx(m_hMod, pNamesEx, wGroups); //   
   for (WORD j=0; j<wGroups; j++) {
      CRcNameEx &name = pNamesEx[j];
      wFrames = ::GetIconFrames(m_hMod, name.getName_raw(), name.getLang());
      ARR_IcoFrames arr;
      for (i=0; i<wFrames; i++) {
         HICON hIco = ::LoadIcon(m_hMod, i, name.getName_raw(), name.getLang());
         if (hIco == NULL)
            continue;
         arr.push_back(CFrameInfo(
            hIco,
            ::SizeIcon(m_hMod, i, name.getName_raw(), name.getLang())));
      }
      m_arrIcoRcAllFramesFromGroupLng.push_back(CIcoInfo(
         arr,
         name.getNameValue()+ _T(" (")+ name.getLocaleValue()+ _T(')')));
   }
   delete [] pNamesEx;
   InvalidateRect(NULL, TRUE);

}

HANDLE FindFirstFile(IN LPCTSTR szDirName, IN LPCTSTR szMask, OUT CString &strFileFirst) {
   if (!szDirName || !szDirName[0] /*|| !szMask || !szMask[0] || */) {
      ::SetLastError(ERROR_INVALID_PARAMETER);
      return INVALID_HANDLE_VALUE;
   }
   CString strDirName(szDirName);
   if (strDirName[strDirName.GetLength()-1] != _T('\\')) {
      strDirName += _T('\\');
   }
   WIN32_FIND_DATA findFileData;
   HANDLE hFindFile = ::FindFirstFile(strDirName + ((szMask && szMask[0]) ? szMask : _T("*")), &findFileData);
   if (hFindFile != INVALID_HANDLE_VALUE) {
      if (!(findFileData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)) {
         strFileFirst = findFileData.cFileName;
      }
   }
   return hFindFile;
}

BOOL FindNextFile(IN HANDLE hFindFile, OUT CString &strFileNext) {
   WIN32_FIND_DATA findFileData;
   DWORD dwErrCode = NO_ERROR;
   BOOL bRes = ::FindNextFile(hFindFile, &findFileData);
   if (!bRes) {
      dwErrCode = ::GetLastError();
   } else {
      if (!(findFileData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)) {
         strFileNext = findFileData.cFileName;
      } else {
         strFileNext.Empty();
      }
   }
   ::SetLastError(dwErrCode);
   return bRes;
}

void CMainDlg::LoadIcoFromDir() {
   //     
   CString strIcoFile;
   ::SetCurrentDirectory(m_strImageFolder);
   HANDLE hFindFile = FindFirstFile(m_strImageFolder, _T("*.ico"), strIcoFile);
   if (hFindFile != INVALID_HANDLE_VALUE) {
      do {
         WORD wFrames = ::GetIconFrames(strIcoFile);
         ARR_IcoFrames arr;
         for (WORD i=0; i<wFrames; i++) {
            HICON hIco = ::LoadIcon(i, strIcoFile);
            if (hIco == NULL)
               continue;
            arr.push_back(CFrameInfo(
               hIco,
               ::SizeIcon(i, strIcoFile)));
         }
         m_arrIcoAllDirFrames.push_back(CIcoInfo(arr, strIcoFile));
      } while(FindNextFile(hFindFile, strIcoFile));
      DWORD dwErrCode = ::GetLastError();
      _ASSERT(ERROR_NO_MORE_FILES == dwErrCode);
      BOOL bRes = ::FindClose(hFindFile); _ASSERT(bRes); hFindFile = NULL;
   }
   InvalidateRect(NULL, TRUE);
}

void CMainDlg::LoadBmpFromModule() {
   //  bipmap'   (  ) (    )
   WORD wBitmaps = GetBitmapCount(m_hMod, FALSE); //  
   CRcName *pNames = new CRcName[wBitmaps];
   GetBitmapGroupNames(m_hMod, pNames, wBitmaps); //   bitmap
   WORD j=0;
   for (j=0; j<wBitmaps; j++) {
      CRcName &name = pNames[j];
      HBITMAP hBmp = ::LoadBitmapEx(m_hMod, name.getName_raw());
      if (hBmp == NULL)
         continue;
      m_arrBmpRcAll.push_back(CBmpInfo(
         hBmp,
         ::SizeBitmap(m_hMod, name.getName_raw()),
         name.getNameValue()));
   }
   delete [] pNames;

   //  bipmap'   (  )
   wBitmaps = GetBitmapCount(m_hMod, TRUE); //  
   CRcNameEx *pNamesEx = new CRcNameEx[wBitmaps];
   GetBitmapGroupNamesEx(m_hMod, pNamesEx, wBitmaps); //   bitmap
   for (j=0; j<wBitmaps; j++) {
      CRcNameEx &name = pNamesEx[j];
      HBITMAP hBmp = ::LoadBitmap(m_hMod, name.getName_raw(), name.getLang());
      if (hBmp == NULL)
         continue;
      m_arrBmpRcAllLng.push_back(CBmpInfo(
         hBmp,
         ::SizeBitmap(m_hMod, name.getName_raw(), name.getLang()),
         name.getNameValue() + _T(" (")+name.getLocaleValue()+_T(')')));
   }
   delete [] pNamesEx;
   InvalidateRect(NULL, TRUE);
}

void CMainDlg::LoadBmpFromDir() {
   //  bitmap'  
   CString strBmpFile;
   ::SetCurrentDirectory(m_strImageFolder);
   HANDLE hFindFile = FindFirstFile(m_strImageFolder, _T("*.bmp"), strBmpFile);
   if (hFindFile != INVALID_HANDLE_VALUE) {
      do {
         HBITMAP hBmp = ::LoadBitmap(strBmpFile);
         if (hBmp == NULL)
            continue;
         m_arrBmpDirAll.push_back(CBmpInfo(hBmp, ::SizeBitmap(strBmpFile), strBmpFile));
      } while(FindNextFile(hFindFile, strBmpFile));
      DWORD dwErrCode = ::GetLastError();
      _ASSERT(ERROR_NO_MORE_FILES == dwErrCode);
      BOOL bRes = ::FindClose(hFindFile); _ASSERT(bRes); hFindFile = NULL;
   }

}
